// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: event/Event.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Event {

  /// <summary>Holder for reflection information generated from event/Event.proto</summary>
  public static partial class EventReflection {

    #region Descriptor
    /// <summary>File descriptor for event/Event.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static EventReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "ChFldmVudC9FdmVudC5wcm90bxIFZXZlbnQaH2dvb2dsZS9wcm90b2J1Zi90",
            "aW1lc3RhbXAucHJvdG8aImV2ZW50L21vbml0b3JpbmcvRGV2aWNlQWxhcm0u",
            "cHJvdG8aI2V2ZW50L21vbml0b3JpbmcvR2VuZXJpY0FsYXJtLnByb3RvGiNl",
            "dmVudC9tb25pdG9yaW5nL1dlYXRoZXJBbGFybS5wcm90bxolZXZlbnQvY29u",
            "bmVjdGl2aXR5L0Nvbm5lY3Rpdml0eS5wcm90bxoZZXZlbnQvZ2VuZXJpYy9T",
            "dGF0ZS5wcm90bxoiZXZlbnQvZ2VuZXJpYy9BbGFybXNSZXNvbHZlZC5wcm90",
            "bxojZXZlbnQvZ2VuZXJpYy9EZXZpY2VEaXNjb3ZlcnkucHJvdG8aJGV2ZW50",
            "L2NoYXJnZXIvU3RhcnRUcmFuc2FjdGlvbi5wcm90bxomZXZlbnQvY2hhcmdl",
            "ci9TdGF0dXNOb3RpZmljYXRpb24ucHJvdG8aI2V2ZW50L2NoYXJnZXIvU3Rv",
            "cFRyYW5zYWN0aW9uLnByb3RvGiFldmVudC9nZW5lcmljL1JlcG9ydENyZWF0",
            "ZWQucHJvdG8ijwYKBUV2ZW50Ei0KCXRpbWVzdGFtcBgBIAEoCzIaLmdvb2ds",
            "ZS5wcm90b2J1Zi5UaW1lc3RhbXASLgoKb2NjdXJyZWRBdBgCIAEoCzIaLmdv",
            "b2dsZS5wcm90b2J1Zi5UaW1lc3RhbXASQQoXbW9uaXRvcmluZ19kZXZpY2Vf",
            "YWxhcm0Y6QcgASgLMh0uZXZlbnQubW9uaXRvcmluZy5EZXZpY2VBbGFybUgA",
            "EkMKGG1vbml0b3JpbmdfZ2VuZXJpY19hbGFybRjqByABKAsyHi5ldmVudC5t",
            "b25pdG9yaW5nLkdlbmVyaWNBbGFybUgAEkMKGG1vbml0b3Jpbmdfd2VhdGhl",
            "cl9hbGFybRjrByABKAsyHi5ldmVudC5tb25pdG9yaW5nLldlYXRoZXJBbGFy",
            "bUgAEiYKBXN0YXRlGNEPIAEoCzIULmV2ZW50LmdlbmVyaWMuU3RhdGVIABI7",
            "ChBkZXZpY2VfZGlzY292ZXJ5GNIPIAEoCzIeLmV2ZW50LmdlbmVyaWMuRGV2",
            "aWNlRGlzY292ZXJ5SAASOQoPYWxhcm1zX3Jlc29sdmVkGNMPIAEoCzIdLmV2",
            "ZW50LmdlbmVyaWMuQWxhcm1zUmVzb2x2ZWRIABI3Cg5yZXBvcnRfY3JlYXRl",
            "ZBjUDyABKAsyHC5ldmVudC5nZW5lcmljLlJlcG9ydENyZWF0ZWRIABI5Cgxj",
            "b25uZWN0aXZpdHkYuRcgASgLMiAuZXZlbnQuY29ubmVjdGl2aXR5LkNvbm5l",
            "Y3Rpdml0eUgAEj0KEXN0YXJ0X3RyYW5zYWN0aW9uGKEfIAEoCzIfLmV2ZW50",
            "LmNoYXJnZXIuU3RhcnRUcmFuc2FjdGlvbkgAEjsKEHN0b3BfdHJhbnNhY3Rp",
            "b24Yoh8gASgLMh4uZXZlbnQuY2hhcmdlci5TdG9wVHJhbnNhY3Rpb25IABJB",
            "ChNzdGF0dXNfbm90aWZpY2F0aW9uGKMfIAEoCzIhLmV2ZW50LmNoYXJnZXIu",
            "U3RhdHVzTm90aWZpY2F0aW9uSABCBwoFZXZlbnRCZQoXY29tLmNvZGlibHku",
            "bW9kZWwuZXZlbnRCCkV2ZW50UHJvdG/KAhdEb21haW5Nb2RlbFxQcm90b1xF",
            "dmVudOICI0RvbWFpbk1vZGVsXFByb3RvXEV2ZW50XEdQQk1ldGFkYXRhYgZw",
            "cm90bzM="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, global::Event.Monitoring.DeviceAlarmReflection.Descriptor, global::Event.Monitoring.GenericAlarmReflection.Descriptor, global::Event.Monitoring.WeatherAlarmReflection.Descriptor, global::Event.Connectivity.ConnectivityReflection.Descriptor, global::Event.Generic.StateReflection.Descriptor, global::Event.Generic.AlarmsResolvedReflection.Descriptor, global::Event.Generic.DeviceDiscoveryReflection.Descriptor, global::Event.Charger.StartTransactionReflection.Descriptor, global::Event.Charger.StatusNotificationReflection.Descriptor, global::Event.Charger.StopTransactionReflection.Descriptor, global::Event.Generic.ReportCreatedReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Event.Event), global::Event.Event.Parser, new[]{ "Timestamp", "OccurredAt", "MonitoringDeviceAlarm", "MonitoringGenericAlarm", "MonitoringWeatherAlarm", "State", "DeviceDiscovery", "AlarmsResolved", "ReportCreated", "Connectivity", "StartTransaction", "StopTransaction", "StatusNotification" }, new[]{ "Event" }, null, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class Event : pb::IMessage<Event>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Event> _parser = new pb::MessageParser<Event>(() => new Event());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<Event> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Event.EventReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Event() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Event(Event other) : this() {
      timestamp_ = other.timestamp_ != null ? other.timestamp_.Clone() : null;
      occurredAt_ = other.occurredAt_ != null ? other.occurredAt_.Clone() : null;
      switch (other.EventCase) {
        case EventOneofCase.MonitoringDeviceAlarm:
          MonitoringDeviceAlarm = other.MonitoringDeviceAlarm.Clone();
          break;
        case EventOneofCase.MonitoringGenericAlarm:
          MonitoringGenericAlarm = other.MonitoringGenericAlarm.Clone();
          break;
        case EventOneofCase.MonitoringWeatherAlarm:
          MonitoringWeatherAlarm = other.MonitoringWeatherAlarm.Clone();
          break;
        case EventOneofCase.State:
          State = other.State.Clone();
          break;
        case EventOneofCase.DeviceDiscovery:
          DeviceDiscovery = other.DeviceDiscovery.Clone();
          break;
        case EventOneofCase.AlarmsResolved:
          AlarmsResolved = other.AlarmsResolved.Clone();
          break;
        case EventOneofCase.ReportCreated:
          ReportCreated = other.ReportCreated.Clone();
          break;
        case EventOneofCase.Connectivity:
          Connectivity = other.Connectivity.Clone();
          break;
        case EventOneofCase.StartTransaction:
          StartTransaction = other.StartTransaction.Clone();
          break;
        case EventOneofCase.StopTransaction:
          StopTransaction = other.StopTransaction.Clone();
          break;
        case EventOneofCase.StatusNotification:
          StatusNotification = other.StatusNotification.Clone();
          break;
      }

      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Event Clone() {
      return new Event(this);
    }

    /// <summary>Field number for the "timestamp" field.</summary>
    public const int TimestampFieldNumber = 1;
    private global::Google.Protobuf.WellKnownTypes.Timestamp timestamp_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Google.Protobuf.WellKnownTypes.Timestamp Timestamp {
      get { return timestamp_; }
      set {
        timestamp_ = value;
      }
    }

    /// <summary>Field number for the "occurredAt" field.</summary>
    public const int OccurredAtFieldNumber = 2;
    private global::Google.Protobuf.WellKnownTypes.Timestamp occurredAt_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Google.Protobuf.WellKnownTypes.Timestamp OccurredAt {
      get { return occurredAt_; }
      set {
        occurredAt_ = value;
      }
    }

    /// <summary>Field number for the "monitoring_device_alarm" field.</summary>
    public const int MonitoringDeviceAlarmFieldNumber = 1001;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Monitoring.DeviceAlarm MonitoringDeviceAlarm {
      get { return eventCase_ == EventOneofCase.MonitoringDeviceAlarm ? (global::Event.Monitoring.DeviceAlarm) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.MonitoringDeviceAlarm;
      }
    }

    /// <summary>Field number for the "monitoring_generic_alarm" field.</summary>
    public const int MonitoringGenericAlarmFieldNumber = 1002;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Monitoring.GenericAlarm MonitoringGenericAlarm {
      get { return eventCase_ == EventOneofCase.MonitoringGenericAlarm ? (global::Event.Monitoring.GenericAlarm) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.MonitoringGenericAlarm;
      }
    }

    /// <summary>Field number for the "monitoring_weather_alarm" field.</summary>
    public const int MonitoringWeatherAlarmFieldNumber = 1003;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Monitoring.WeatherAlarm MonitoringWeatherAlarm {
      get { return eventCase_ == EventOneofCase.MonitoringWeatherAlarm ? (global::Event.Monitoring.WeatherAlarm) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.MonitoringWeatherAlarm;
      }
    }

    /// <summary>Field number for the "state" field.</summary>
    public const int StateFieldNumber = 2001;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Generic.State State {
      get { return eventCase_ == EventOneofCase.State ? (global::Event.Generic.State) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.State;
      }
    }

    /// <summary>Field number for the "device_discovery" field.</summary>
    public const int DeviceDiscoveryFieldNumber = 2002;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Generic.DeviceDiscovery DeviceDiscovery {
      get { return eventCase_ == EventOneofCase.DeviceDiscovery ? (global::Event.Generic.DeviceDiscovery) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.DeviceDiscovery;
      }
    }

    /// <summary>Field number for the "alarms_resolved" field.</summary>
    public const int AlarmsResolvedFieldNumber = 2003;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Generic.AlarmsResolved AlarmsResolved {
      get { return eventCase_ == EventOneofCase.AlarmsResolved ? (global::Event.Generic.AlarmsResolved) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.AlarmsResolved;
      }
    }

    /// <summary>Field number for the "report_created" field.</summary>
    public const int ReportCreatedFieldNumber = 2004;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Generic.ReportCreated ReportCreated {
      get { return eventCase_ == EventOneofCase.ReportCreated ? (global::Event.Generic.ReportCreated) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.ReportCreated;
      }
    }

    /// <summary>Field number for the "connectivity" field.</summary>
    public const int ConnectivityFieldNumber = 3001;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Connectivity.Connectivity Connectivity {
      get { return eventCase_ == EventOneofCase.Connectivity ? (global::Event.Connectivity.Connectivity) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.Connectivity;
      }
    }

    /// <summary>Field number for the "start_transaction" field.</summary>
    public const int StartTransactionFieldNumber = 4001;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Charger.StartTransaction StartTransaction {
      get { return eventCase_ == EventOneofCase.StartTransaction ? (global::Event.Charger.StartTransaction) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.StartTransaction;
      }
    }

    /// <summary>Field number for the "stop_transaction" field.</summary>
    public const int StopTransactionFieldNumber = 4002;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Charger.StopTransaction StopTransaction {
      get { return eventCase_ == EventOneofCase.StopTransaction ? (global::Event.Charger.StopTransaction) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.StopTransaction;
      }
    }

    /// <summary>Field number for the "status_notification" field.</summary>
    public const int StatusNotificationFieldNumber = 4003;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Event.Charger.StatusNotification StatusNotification {
      get { return eventCase_ == EventOneofCase.StatusNotification ? (global::Event.Charger.StatusNotification) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.StatusNotification;
      }
    }

    private object event_;
    /// <summary>Enum of possible cases for the "event" oneof.</summary>
    public enum EventOneofCase {
      None = 0,
      MonitoringDeviceAlarm = 1001,
      MonitoringGenericAlarm = 1002,
      MonitoringWeatherAlarm = 1003,
      State = 2001,
      DeviceDiscovery = 2002,
      AlarmsResolved = 2003,
      ReportCreated = 2004,
      Connectivity = 3001,
      StartTransaction = 4001,
      StopTransaction = 4002,
      StatusNotification = 4003,
    }
    private EventOneofCase eventCase_ = EventOneofCase.None;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public EventOneofCase EventCase {
      get { return eventCase_; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearEvent() {
      eventCase_ = EventOneofCase.None;
      event_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as Event);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(Event other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (!object.Equals(Timestamp, other.Timestamp)) return false;
      if (!object.Equals(OccurredAt, other.OccurredAt)) return false;
      if (!object.Equals(MonitoringDeviceAlarm, other.MonitoringDeviceAlarm)) return false;
      if (!object.Equals(MonitoringGenericAlarm, other.MonitoringGenericAlarm)) return false;
      if (!object.Equals(MonitoringWeatherAlarm, other.MonitoringWeatherAlarm)) return false;
      if (!object.Equals(State, other.State)) return false;
      if (!object.Equals(DeviceDiscovery, other.DeviceDiscovery)) return false;
      if (!object.Equals(AlarmsResolved, other.AlarmsResolved)) return false;
      if (!object.Equals(ReportCreated, other.ReportCreated)) return false;
      if (!object.Equals(Connectivity, other.Connectivity)) return false;
      if (!object.Equals(StartTransaction, other.StartTransaction)) return false;
      if (!object.Equals(StopTransaction, other.StopTransaction)) return false;
      if (!object.Equals(StatusNotification, other.StatusNotification)) return false;
      if (EventCase != other.EventCase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (timestamp_ != null) hash ^= Timestamp.GetHashCode();
      if (occurredAt_ != null) hash ^= OccurredAt.GetHashCode();
      if (eventCase_ == EventOneofCase.MonitoringDeviceAlarm) hash ^= MonitoringDeviceAlarm.GetHashCode();
      if (eventCase_ == EventOneofCase.MonitoringGenericAlarm) hash ^= MonitoringGenericAlarm.GetHashCode();
      if (eventCase_ == EventOneofCase.MonitoringWeatherAlarm) hash ^= MonitoringWeatherAlarm.GetHashCode();
      if (eventCase_ == EventOneofCase.State) hash ^= State.GetHashCode();
      if (eventCase_ == EventOneofCase.DeviceDiscovery) hash ^= DeviceDiscovery.GetHashCode();
      if (eventCase_ == EventOneofCase.AlarmsResolved) hash ^= AlarmsResolved.GetHashCode();
      if (eventCase_ == EventOneofCase.ReportCreated) hash ^= ReportCreated.GetHashCode();
      if (eventCase_ == EventOneofCase.Connectivity) hash ^= Connectivity.GetHashCode();
      if (eventCase_ == EventOneofCase.StartTransaction) hash ^= StartTransaction.GetHashCode();
      if (eventCase_ == EventOneofCase.StopTransaction) hash ^= StopTransaction.GetHashCode();
      if (eventCase_ == EventOneofCase.StatusNotification) hash ^= StatusNotification.GetHashCode();
      hash ^= (int) eventCase_;
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (timestamp_ != null) {
        output.WriteRawTag(10);
        output.WriteMessage(Timestamp);
      }
      if (occurredAt_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(OccurredAt);
      }
      if (eventCase_ == EventOneofCase.MonitoringDeviceAlarm) {
        output.WriteRawTag(202, 62);
        output.WriteMessage(MonitoringDeviceAlarm);
      }
      if (eventCase_ == EventOneofCase.MonitoringGenericAlarm) {
        output.WriteRawTag(210, 62);
        output.WriteMessage(MonitoringGenericAlarm);
      }
      if (eventCase_ == EventOneofCase.MonitoringWeatherAlarm) {
        output.WriteRawTag(218, 62);
        output.WriteMessage(MonitoringWeatherAlarm);
      }
      if (eventCase_ == EventOneofCase.State) {
        output.WriteRawTag(138, 125);
        output.WriteMessage(State);
      }
      if (eventCase_ == EventOneofCase.DeviceDiscovery) {
        output.WriteRawTag(146, 125);
        output.WriteMessage(DeviceDiscovery);
      }
      if (eventCase_ == EventOneofCase.AlarmsResolved) {
        output.WriteRawTag(154, 125);
        output.WriteMessage(AlarmsResolved);
      }
      if (eventCase_ == EventOneofCase.ReportCreated) {
        output.WriteRawTag(162, 125);
        output.WriteMessage(ReportCreated);
      }
      if (eventCase_ == EventOneofCase.Connectivity) {
        output.WriteRawTag(202, 187, 1);
        output.WriteMessage(Connectivity);
      }
      if (eventCase_ == EventOneofCase.StartTransaction) {
        output.WriteRawTag(138, 250, 1);
        output.WriteMessage(StartTransaction);
      }
      if (eventCase_ == EventOneofCase.StopTransaction) {
        output.WriteRawTag(146, 250, 1);
        output.WriteMessage(StopTransaction);
      }
      if (eventCase_ == EventOneofCase.StatusNotification) {
        output.WriteRawTag(154, 250, 1);
        output.WriteMessage(StatusNotification);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (timestamp_ != null) {
        output.WriteRawTag(10);
        output.WriteMessage(Timestamp);
      }
      if (occurredAt_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(OccurredAt);
      }
      if (eventCase_ == EventOneofCase.MonitoringDeviceAlarm) {
        output.WriteRawTag(202, 62);
        output.WriteMessage(MonitoringDeviceAlarm);
      }
      if (eventCase_ == EventOneofCase.MonitoringGenericAlarm) {
        output.WriteRawTag(210, 62);
        output.WriteMessage(MonitoringGenericAlarm);
      }
      if (eventCase_ == EventOneofCase.MonitoringWeatherAlarm) {
        output.WriteRawTag(218, 62);
        output.WriteMessage(MonitoringWeatherAlarm);
      }
      if (eventCase_ == EventOneofCase.State) {
        output.WriteRawTag(138, 125);
        output.WriteMessage(State);
      }
      if (eventCase_ == EventOneofCase.DeviceDiscovery) {
        output.WriteRawTag(146, 125);
        output.WriteMessage(DeviceDiscovery);
      }
      if (eventCase_ == EventOneofCase.AlarmsResolved) {
        output.WriteRawTag(154, 125);
        output.WriteMessage(AlarmsResolved);
      }
      if (eventCase_ == EventOneofCase.ReportCreated) {
        output.WriteRawTag(162, 125);
        output.WriteMessage(ReportCreated);
      }
      if (eventCase_ == EventOneofCase.Connectivity) {
        output.WriteRawTag(202, 187, 1);
        output.WriteMessage(Connectivity);
      }
      if (eventCase_ == EventOneofCase.StartTransaction) {
        output.WriteRawTag(138, 250, 1);
        output.WriteMessage(StartTransaction);
      }
      if (eventCase_ == EventOneofCase.StopTransaction) {
        output.WriteRawTag(146, 250, 1);
        output.WriteMessage(StopTransaction);
      }
      if (eventCase_ == EventOneofCase.StatusNotification) {
        output.WriteRawTag(154, 250, 1);
        output.WriteMessage(StatusNotification);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (timestamp_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(Timestamp);
      }
      if (occurredAt_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(OccurredAt);
      }
      if (eventCase_ == EventOneofCase.MonitoringDeviceAlarm) {
        size += 2 + pb::CodedOutputStream.ComputeMessageSize(MonitoringDeviceAlarm);
      }
      if (eventCase_ == EventOneofCase.MonitoringGenericAlarm) {
        size += 2 + pb::CodedOutputStream.ComputeMessageSize(MonitoringGenericAlarm);
      }
      if (eventCase_ == EventOneofCase.MonitoringWeatherAlarm) {
        size += 2 + pb::CodedOutputStream.ComputeMessageSize(MonitoringWeatherAlarm);
      }
      if (eventCase_ == EventOneofCase.State) {
        size += 2 + pb::CodedOutputStream.ComputeMessageSize(State);
      }
      if (eventCase_ == EventOneofCase.DeviceDiscovery) {
        size += 2 + pb::CodedOutputStream.ComputeMessageSize(DeviceDiscovery);
      }
      if (eventCase_ == EventOneofCase.AlarmsResolved) {
        size += 2 + pb::CodedOutputStream.ComputeMessageSize(AlarmsResolved);
      }
      if (eventCase_ == EventOneofCase.ReportCreated) {
        size += 2 + pb::CodedOutputStream.ComputeMessageSize(ReportCreated);
      }
      if (eventCase_ == EventOneofCase.Connectivity) {
        size += 3 + pb::CodedOutputStream.ComputeMessageSize(Connectivity);
      }
      if (eventCase_ == EventOneofCase.StartTransaction) {
        size += 3 + pb::CodedOutputStream.ComputeMessageSize(StartTransaction);
      }
      if (eventCase_ == EventOneofCase.StopTransaction) {
        size += 3 + pb::CodedOutputStream.ComputeMessageSize(StopTransaction);
      }
      if (eventCase_ == EventOneofCase.StatusNotification) {
        size += 3 + pb::CodedOutputStream.ComputeMessageSize(StatusNotification);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(Event other) {
      if (other == null) {
        return;
      }
      if (other.timestamp_ != null) {
        if (timestamp_ == null) {
          Timestamp = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        Timestamp.MergeFrom(other.Timestamp);
      }
      if (other.occurredAt_ != null) {
        if (occurredAt_ == null) {
          OccurredAt = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        OccurredAt.MergeFrom(other.OccurredAt);
      }
      switch (other.EventCase) {
        case EventOneofCase.MonitoringDeviceAlarm:
          if (MonitoringDeviceAlarm == null) {
            MonitoringDeviceAlarm = new global::Event.Monitoring.DeviceAlarm();
          }
          MonitoringDeviceAlarm.MergeFrom(other.MonitoringDeviceAlarm);
          break;
        case EventOneofCase.MonitoringGenericAlarm:
          if (MonitoringGenericAlarm == null) {
            MonitoringGenericAlarm = new global::Event.Monitoring.GenericAlarm();
          }
          MonitoringGenericAlarm.MergeFrom(other.MonitoringGenericAlarm);
          break;
        case EventOneofCase.MonitoringWeatherAlarm:
          if (MonitoringWeatherAlarm == null) {
            MonitoringWeatherAlarm = new global::Event.Monitoring.WeatherAlarm();
          }
          MonitoringWeatherAlarm.MergeFrom(other.MonitoringWeatherAlarm);
          break;
        case EventOneofCase.State:
          if (State == null) {
            State = new global::Event.Generic.State();
          }
          State.MergeFrom(other.State);
          break;
        case EventOneofCase.DeviceDiscovery:
          if (DeviceDiscovery == null) {
            DeviceDiscovery = new global::Event.Generic.DeviceDiscovery();
          }
          DeviceDiscovery.MergeFrom(other.DeviceDiscovery);
          break;
        case EventOneofCase.AlarmsResolved:
          if (AlarmsResolved == null) {
            AlarmsResolved = new global::Event.Generic.AlarmsResolved();
          }
          AlarmsResolved.MergeFrom(other.AlarmsResolved);
          break;
        case EventOneofCase.ReportCreated:
          if (ReportCreated == null) {
            ReportCreated = new global::Event.Generic.ReportCreated();
          }
          ReportCreated.MergeFrom(other.ReportCreated);
          break;
        case EventOneofCase.Connectivity:
          if (Connectivity == null) {
            Connectivity = new global::Event.Connectivity.Connectivity();
          }
          Connectivity.MergeFrom(other.Connectivity);
          break;
        case EventOneofCase.StartTransaction:
          if (StartTransaction == null) {
            StartTransaction = new global::Event.Charger.StartTransaction();
          }
          StartTransaction.MergeFrom(other.StartTransaction);
          break;
        case EventOneofCase.StopTransaction:
          if (StopTransaction == null) {
            StopTransaction = new global::Event.Charger.StopTransaction();
          }
          StopTransaction.MergeFrom(other.StopTransaction);
          break;
        case EventOneofCase.StatusNotification:
          if (StatusNotification == null) {
            StatusNotification = new global::Event.Charger.StatusNotification();
          }
          StatusNotification.MergeFrom(other.StatusNotification);
          break;
      }

      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            if (timestamp_ == null) {
              Timestamp = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(Timestamp);
            break;
          }
          case 18: {
            if (occurredAt_ == null) {
              OccurredAt = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(OccurredAt);
            break;
          }
          case 8010: {
            global::Event.Monitoring.DeviceAlarm subBuilder = new global::Event.Monitoring.DeviceAlarm();
            if (eventCase_ == EventOneofCase.MonitoringDeviceAlarm) {
              subBuilder.MergeFrom(MonitoringDeviceAlarm);
            }
            input.ReadMessage(subBuilder);
            MonitoringDeviceAlarm = subBuilder;
            break;
          }
          case 8018: {
            global::Event.Monitoring.GenericAlarm subBuilder = new global::Event.Monitoring.GenericAlarm();
            if (eventCase_ == EventOneofCase.MonitoringGenericAlarm) {
              subBuilder.MergeFrom(MonitoringGenericAlarm);
            }
            input.ReadMessage(subBuilder);
            MonitoringGenericAlarm = subBuilder;
            break;
          }
          case 8026: {
            global::Event.Monitoring.WeatherAlarm subBuilder = new global::Event.Monitoring.WeatherAlarm();
            if (eventCase_ == EventOneofCase.MonitoringWeatherAlarm) {
              subBuilder.MergeFrom(MonitoringWeatherAlarm);
            }
            input.ReadMessage(subBuilder);
            MonitoringWeatherAlarm = subBuilder;
            break;
          }
          case 16010: {
            global::Event.Generic.State subBuilder = new global::Event.Generic.State();
            if (eventCase_ == EventOneofCase.State) {
              subBuilder.MergeFrom(State);
            }
            input.ReadMessage(subBuilder);
            State = subBuilder;
            break;
          }
          case 16018: {
            global::Event.Generic.DeviceDiscovery subBuilder = new global::Event.Generic.DeviceDiscovery();
            if (eventCase_ == EventOneofCase.DeviceDiscovery) {
              subBuilder.MergeFrom(DeviceDiscovery);
            }
            input.ReadMessage(subBuilder);
            DeviceDiscovery = subBuilder;
            break;
          }
          case 16026: {
            global::Event.Generic.AlarmsResolved subBuilder = new global::Event.Generic.AlarmsResolved();
            if (eventCase_ == EventOneofCase.AlarmsResolved) {
              subBuilder.MergeFrom(AlarmsResolved);
            }
            input.ReadMessage(subBuilder);
            AlarmsResolved = subBuilder;
            break;
          }
          case 16034: {
            global::Event.Generic.ReportCreated subBuilder = new global::Event.Generic.ReportCreated();
            if (eventCase_ == EventOneofCase.ReportCreated) {
              subBuilder.MergeFrom(ReportCreated);
            }
            input.ReadMessage(subBuilder);
            ReportCreated = subBuilder;
            break;
          }
          case 24010: {
            global::Event.Connectivity.Connectivity subBuilder = new global::Event.Connectivity.Connectivity();
            if (eventCase_ == EventOneofCase.Connectivity) {
              subBuilder.MergeFrom(Connectivity);
            }
            input.ReadMessage(subBuilder);
            Connectivity = subBuilder;
            break;
          }
          case 32010: {
            global::Event.Charger.StartTransaction subBuilder = new global::Event.Charger.StartTransaction();
            if (eventCase_ == EventOneofCase.StartTransaction) {
              subBuilder.MergeFrom(StartTransaction);
            }
            input.ReadMessage(subBuilder);
            StartTransaction = subBuilder;
            break;
          }
          case 32018: {
            global::Event.Charger.StopTransaction subBuilder = new global::Event.Charger.StopTransaction();
            if (eventCase_ == EventOneofCase.StopTransaction) {
              subBuilder.MergeFrom(StopTransaction);
            }
            input.ReadMessage(subBuilder);
            StopTransaction = subBuilder;
            break;
          }
          case 32026: {
            global::Event.Charger.StatusNotification subBuilder = new global::Event.Charger.StatusNotification();
            if (eventCase_ == EventOneofCase.StatusNotification) {
              subBuilder.MergeFrom(StatusNotification);
            }
            input.ReadMessage(subBuilder);
            StatusNotification = subBuilder;
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            if (timestamp_ == null) {
              Timestamp = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(Timestamp);
            break;
          }
          case 18: {
            if (occurredAt_ == null) {
              OccurredAt = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(OccurredAt);
            break;
          }
          case 8010: {
            global::Event.Monitoring.DeviceAlarm subBuilder = new global::Event.Monitoring.DeviceAlarm();
            if (eventCase_ == EventOneofCase.MonitoringDeviceAlarm) {
              subBuilder.MergeFrom(MonitoringDeviceAlarm);
            }
            input.ReadMessage(subBuilder);
            MonitoringDeviceAlarm = subBuilder;
            break;
          }
          case 8018: {
            global::Event.Monitoring.GenericAlarm subBuilder = new global::Event.Monitoring.GenericAlarm();
            if (eventCase_ == EventOneofCase.MonitoringGenericAlarm) {
              subBuilder.MergeFrom(MonitoringGenericAlarm);
            }
            input.ReadMessage(subBuilder);
            MonitoringGenericAlarm = subBuilder;
            break;
          }
          case 8026: {
            global::Event.Monitoring.WeatherAlarm subBuilder = new global::Event.Monitoring.WeatherAlarm();
            if (eventCase_ == EventOneofCase.MonitoringWeatherAlarm) {
              subBuilder.MergeFrom(MonitoringWeatherAlarm);
            }
            input.ReadMessage(subBuilder);
            MonitoringWeatherAlarm = subBuilder;
            break;
          }
          case 16010: {
            global::Event.Generic.State subBuilder = new global::Event.Generic.State();
            if (eventCase_ == EventOneofCase.State) {
              subBuilder.MergeFrom(State);
            }
            input.ReadMessage(subBuilder);
            State = subBuilder;
            break;
          }
          case 16018: {
            global::Event.Generic.DeviceDiscovery subBuilder = new global::Event.Generic.DeviceDiscovery();
            if (eventCase_ == EventOneofCase.DeviceDiscovery) {
              subBuilder.MergeFrom(DeviceDiscovery);
            }
            input.ReadMessage(subBuilder);
            DeviceDiscovery = subBuilder;
            break;
          }
          case 16026: {
            global::Event.Generic.AlarmsResolved subBuilder = new global::Event.Generic.AlarmsResolved();
            if (eventCase_ == EventOneofCase.AlarmsResolved) {
              subBuilder.MergeFrom(AlarmsResolved);
            }
            input.ReadMessage(subBuilder);
            AlarmsResolved = subBuilder;
            break;
          }
          case 16034: {
            global::Event.Generic.ReportCreated subBuilder = new global::Event.Generic.ReportCreated();
            if (eventCase_ == EventOneofCase.ReportCreated) {
              subBuilder.MergeFrom(ReportCreated);
            }
            input.ReadMessage(subBuilder);
            ReportCreated = subBuilder;
            break;
          }
          case 24010: {
            global::Event.Connectivity.Connectivity subBuilder = new global::Event.Connectivity.Connectivity();
            if (eventCase_ == EventOneofCase.Connectivity) {
              subBuilder.MergeFrom(Connectivity);
            }
            input.ReadMessage(subBuilder);
            Connectivity = subBuilder;
            break;
          }
          case 32010: {
            global::Event.Charger.StartTransaction subBuilder = new global::Event.Charger.StartTransaction();
            if (eventCase_ == EventOneofCase.StartTransaction) {
              subBuilder.MergeFrom(StartTransaction);
            }
            input.ReadMessage(subBuilder);
            StartTransaction = subBuilder;
            break;
          }
          case 32018: {
            global::Event.Charger.StopTransaction subBuilder = new global::Event.Charger.StopTransaction();
            if (eventCase_ == EventOneofCase.StopTransaction) {
              subBuilder.MergeFrom(StopTransaction);
            }
            input.ReadMessage(subBuilder);
            StopTransaction = subBuilder;
            break;
          }
          case 32026: {
            global::Event.Charger.StatusNotification subBuilder = new global::Event.Charger.StatusNotification();
            if (eventCase_ == EventOneofCase.StatusNotification) {
              subBuilder.MergeFrom(StatusNotification);
            }
            input.ReadMessage(subBuilder);
            StatusNotification = subBuilder;
            break;
          }
        }
      }
    }
    #endif

  }

  #endregion

}

#endregion Designer generated code
